#verify we're running as root
sudo whoami

#reset output
:> /tmp/rate.DATA
:> /tmp/ping.DATA
echo "0 0" > /tmp/ping.DATA 
echo "0 0" > /tmp/rate.DATA 

#latency  (1 sample per sec)
killall ping
ping -D localhost |   perl -ne 'BEGIN { $|=1 } m/^\[(\d+.?\d*).*seq\=(\d+).*time\=(\d+.?\d*)\s*ms/; print "$1 $2 $3\n"; ' > /tmp/ping.DATA &

#bandwidth (4 samples per sec)
sudo killall tcpdump.hack	
sudo ./tcpdump.hack -ttt -i lo  -n ip  | awk ' {t=$1; s+=$2; if ((t-oldt)>1) { print n++, 8.0*s/(t-oldt)/1000; s=0; oldt=t; fflush() } }'     >> /tmp/rate.DATA & 

#----------------------------------------------------------
#dir=/home/drossi/bin/
#monitor=$dir/tcpdump.hack
#filter=$dir/tcpdump.timesize2rate 
#sudo $monitor -ttt -i lo  -n ip | $filter -t=1000 > /tmp/rate.DATA &
#----------------------------------------------------------
# buffer problems; use unbuffer from expect helps in part..
# unbuffer -p ./tcpdump.hack -ttt -i lo  -n ip  | unbuffer -p awk ' {t +=$1; s+=$2;  if (t>1) { print t/1e6, 8.0*s/t; s=0; t=0; } }'  > /tmp/rate.DATA   
#----------------------------------------------------------
# another smart solution... that does not work :(
#    http://unix.stackexchange.com/questions/25372/turn-off-buffering-in-pipe
# but how to process the stderr then??
#    tcp.dumphack  -ttt -i lo  -n ip 1>&2 |&  ./datarate.pl >  /tmp/rate.DATA &
#----------------------------------------------------------
#sudo ./datarate.sh >> /tmp/rate.DATA & 

#wait to have 1 data point
sleep 1


# refresh plot greph every 1s
echo "#-------------
set multi layout 2,1
set xlab 'time'; 
set ylab 'rate [Kbps]';
plot '/tmp/rate.DATA' u 1:2  t '' w l lc rgb 'red' lw 3; 
set xlab 'sample'; 
set ylab 'rtt [ms]'; 
plot '< cut -d= -f4- /tmp/ping.DATA' u 2:3 w l lc rgb 'blue' lw 3 t '';
pause 1; reread; " > /tmp/plot.gp

export GNUTERM=x11
gnuplot /tmp/plot.gp
