#! /usr/bin/perl -s

use v5.6;

BEGIN { $| = 1 }

$tcpdump="$ENV{HOME}/bin/tcpdump.hack";
$tcpdump="./tcpdump.hack";

open IN, "./tcpdump.hack -ttt -i lo  -n ip |" 
 	or die "Cannot open tcpdump (try running as sudo)"; 

#$tcpdump="$ENV{HOME}/bin/tcpdump.hack";
#$tcpdump="./tcpdump.hack";
# open IN, "unbuffer -p ./monitor-loopback.sh | " 
# 	or die "Cannot open tcpdump (try running as sudo)"; 

# another smart solution:
# http://unix.stackexchange.com/questions/25372/turn-off-buffering-in-pipe
# ./tcpdump.hack -ttt -i lo  -n ip 1>&2 |& cat
# open IN, "unbuffer $tcpdump -ttt -i lo  -n ip 1>&2 |& " 
#	or die "Cannot open tcpdump (try running as sudo)"; 
# but how to process the stderr then??
	
#open STDOUT, "> /tmp/rate.DATA";	
select((select(STDOUT), $|=1)[0]);

$tau ||= 1; #s

print "0 0\n";
while(<>) {
  chomp;
  ($time,$size) = split;

  $s += $size;
  $t += $time;

  print STDERR " $time $size\n" if $d;
  if ( $t >= $tau ) {
    $T += $t/1e6;
    $y = (8*$s/$t);
    print "$T $y\n";
    $s = 0;
    $t = 0;
  }
}
